#!   /usr/bin/env   python
#    coding: utf8
# Copyright CERN, 2011
# Author: Matthieu Cattin <matthieu.cattin@cern.ch>
# Licence: GPL v2 or later.
# Website: http://www.ohwr.org

import sys
import rr
import time
import os


from ptsexcept import *

import fmc_adc

"""
test04: Test Si570 programmable oscillator

Note: Requires test00.py to run first to load the firmware!
"""

SI570_RFREQ = 42
SI570_N1 = 7
SI570_HS_DIV = 2

def main (default_directory='.'):

    """
    path_fpga_loader = '../../../gnurabbit/user/fpga_loader';
    path_firmware = '../firmwares/spec_fmcadc100m14b4cha.bin';

    firmware_loader = os.path.join(default_directory, path_fpga_loader)
    bitstream = os.path.join(default_directory, path_firmware)
    print firmware_loader + ' ' + bitstream
    os.system( firmware_loader + ' ' + bitstream )

    time.sleep(2);
    """

    # Objects declaration
    spec = rr.Gennum() # bind to the SPEC board
    fmc = fmc_adc.CFmcAdc100Ms(spec)

    # Scan i2c bus
    fmc.i2c_scan()

    # Get Si570 configuration
    si570_config = fmc.get_si570_config()
    print("\nPrint Si570 configuration")
    print("RFREQ  : %3.28f") % si570_config[0]
    print("N1     : %d") % si570_config[1]
    print("HS_DIV : %d") % si570_config[2]

    # Check Si570 configuration
    if(int(si570_config[0]) != SI570_RFREQ):
        raise PtsError('Si570 bad reference frequency configured or wrong part is mounted')
    if(si570_config[1] != SI570_N1):
        raise PtsError('Si570 CLKOUT output divider is badly configured or wrong part is mounted')
    if(si570_config[2] != SI570_HS_DIV):
        raise PtsError('Si570 DCO high speed divider is badly configured or wrong part is mounted')


if __name__ == '__main__' :
    main()
